-- Spline
viewer.mode = OVERLAY

function setup()
    points={}
    ship={}
    for i=1,10 do
        points[i]=Point(i*80,math.tointeger(HEIGHT/2))
    end
    selection=0
    len=5
    for i=1,10 do
        ship[i]=Craft(i)
    end
    parameter.boolean("route",true)
    parameter.boolean("keys",true)
    parameter.boolean("ships",false)
    parameter.text("file_name","text")
    parameter.action("save",saved)
    parameter.action("load",loaded)   
end

function draw()
    -- This sets a dark background color 
    background(40, 40, 50)
    strokeWidth(5)
    if keys==true then
        for i,v in ipairs(points) do
            v:draw()
        end
    end

    if route==true then
        for i=1,#points do
            t=0
            while t<1 do  
                p1=i
                p2=i+1 if p2>#points then p2 = p2 - #points end
                p3=i+2 if p3>#points then p3 = p3 - #points end
                p4=i+3 if p4>#points then p4 = p4 - #points end
                a=catmull(points[p1]:getPos(),points[p2]:getPos(),points[p3]:getPos(),
                    points[p4]:getPos(),t)
                ellipse(a.x,a.y,5)
                t=difcat(points[p1]:getPos(),points[p2]:getPos(),points[p3]:getPos(),
                    points[p4]:getPos(),t,len)
            end
        end
    end
    
    if ships==true then
        for i=1,10 do
            ship[i]:draw()
        end
    end
end

function touched(touch)
    if selection==0 and touch.state==BEGAN then
        for i,v in ipairs(points) do
            if v:getPos():dist(vec2(touch.x,touch.y))<40 then 
                selection=i
                break
            end
        end
    end
    if selection~=0 and touch.state==MOVING then
        points[selection]:setPos(touch.x,touch.y)
    end
    if selection~=0 and touch.state==ENDED then
        selection=0
    end
    -- print (selection)
end
function catmull(p0,p1,p2,p3,t)
    x=0.5*((2*p1.x)+(p2.x-p0.x)*t+(2*p0.x-5*p1.x+4*p2.x-p3.x)*t*t+(3*p1.x-p0.x-3*p2.x+p3.x)*t*t*t)
    y=0.5*((2*p1.y)+(p2.y-p0.y)*t+(2*p0.y-5*p1.y+4*p2.y-p3.y)*t*t+(3*p1.y-p0.y-3*p2.y+p3.y)*t*t*t)
    return vec2(x,y)
end
function difcat(p0,p1,p2,p3,t,len)
    dx=0.5*((p2.x-p0.x)+(2*p0.x-5*p1.x+4*p2.x-p3.x)*2*t+(3*p1.x-p0.x-3*p2.x+p3.x)*3*t*t)
    dy=0.5*((p2.y-p0.y)+(2*p0.y-5*p1.y+4*p2.y-p3.y)*2*t+(3*p1.y-p0.y-3*p2.y+p3.y)*3*t*t)
    t=t+(len/math.sqrt(dx^2+dy^2))
    return t,math.deg(vec2(0,0):angleBetween(vec2(dx,dy)))
end

function saved()
    dataString=""
    for i,v in ipairs(points) do
        local pos=v:getPos()
        dataString=dataString..math.ceil(pos.x)..","..math.ceil(pos.y)..","
    end
    dataString = dataString.."x"
    saveGlobalData(file_name.."catmul",dataString)
    
end

function loaded()
    dataString=readGlobalData(file_name.."catmul")
    points={}
    start=1
    finish=1

    
    while string.sub(dataString,finish+1)~="x" do
        table.insert(points,vec2())
        finish = string.find(dataString,",",start)
        x=math.tointeger(string.sub(dataString,start,finish-1))
        start=finish+1
        finish = string.find(dataString,",",start)
        y=math.tointeger(string.sub(dataString,start,finish-1))
        start=finish+1
        points[#points]=Point(x,y)
        
    end

end
